//+------------------------------------------------------------------+
//|                                                  SimbaSystem.mq4 |
//|                                      Simba, programmed by Malcik |
//|                                         http://www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Simba, programmed by Malcik"
#property link      "http://www.forex-tsd.com"

#define MAGICSS  20070129

extern datetime NewsTime;
extern int      MA_Type=1;
extern int      JMA_HMA_Period=13;
extern double   JMA_Phase=0;

datetime LastMinute;
int      LongTrades=0;
int      ShortTrades=0;
double   LastBuyPrice=0;
double   LastSellPrice=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   double SATL; //=iCustom(NULL,PERIOD_H4,"SATL",0,1);
   double SATL_Prev; //iCustom(NULL,PERIOD_H4,"SATL",0,2);
   double Chandelier_Up=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",0,1);
   double Chandelier_Dn=iCustom(NULL,PERIOD_H1,"ChandelierStops_v1",1,1);
   double WPR=iWPR(NULL,0,90,1);
   int    res;
//----
   if(MA_Type==1)
     {
      SATL=iCustom(NULL,PERIOD_H4,"SATL",0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"SATL",0,2);
     }
   if(MA_Type==2)
     {
      SATL=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"HMA",JMA_HMA_Period,0,2);
     }
   if(MA_Type==3)
     {
      SATL=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,1);
      SATL_Prev=iCustom(NULL,PERIOD_H4,"JMA",JMA_HMA_Period,JMA_Phase,0,2);
     }

   if(OrdersTotal()>0)
   {
      for(int i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)
              {
               if(SATL<SATL_Prev || (Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE) || (NewsTime>=Time[0] && NewsTime-Time[0]<=300))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
                 }
              }
            if(OrderType()==OP_SELL)
              {
               if(SATL>SATL_Prev || (Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE) || (NewsTime>=Time[0] && NewsTime-Time[0]<=300))
                 {
                  OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
                 }
              }
           }
        }

      for(i=0;i<OrdersTotal();i++)
        {
         if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICSS)
           {
            if(OrderType()==OP_BUY)
              {
               if(OrderStopLoss()<Chandelier_Up-Point)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Up-Point,OrderTakeProfit(),0,Green);
              }
            if(OrderType()==OP_SELL)
              {
               if(OrderStopLoss()>Chandelier_Dn+Point+Point*4)OrderModify(OrderTicket(),OrderOpenPrice(),Chandelier_Dn+Point+Point*4,OrderTakeProfit(),0,Green);
              }
           }
        }
     }

   if(LastMinute!=Time[0])
     {
      if(SATL<=SATL_Prev || Chandelier_Up==EMPTY_VALUE || WPR>=-5)LongTrades=0;
      if(SATL>=SATL_Prev || Chandelier_Dn==EMPTY_VALUE || WPR<=-95)ShortTrades=0;

      if(LongTrades==0 || Close[0]<=LastBuyPrice-10*Point)
        {
         if(SATL>SATL_Prev && Close[0]>=SATL && Chandelier_Up!=EMPTY_VALUE && Chandelier_Dn==EMPTY_VALUE && Close[0]>=Chandelier_Up+10*Point && Close[0]<=Chandelier_Up+50*Point && WPR<=-95 && ((NewsTime>=Time[0] && NewsTime-Time[0]>1800) || (NewsTime<Time[0] && Time[0]-NewsTime>=600)))// && TimeDayOfWeek(Time[0])<5)))
           {
            res=OrderSend(Symbol(),OP_BUY,1,Ask,3,Chandelier_Up-Point,Bid+(30*Point),"SimbaSystemM1",MAGICSS,0,Green);
            LongTrades++;
            LastBuyPrice=Bid;
           }
        }

      if(ShortTrades==0 || Close[0]>=LastSellPrice+10*Point)
        {
         if(SATL<SATL_Prev && Close[0]<=SATL && Chandelier_Up==EMPTY_VALUE && Chandelier_Dn!=EMPTY_VALUE && Close[0]<=Chandelier_Dn-10*Point && Close[0]>=Chandelier_Dn-50*Point && WPR>=-5 && ((NewsTime>=Time[0] && NewsTime-Time[0]>1800) || (NewsTime<Time[0] && Time[0]-NewsTime>=600)))// && TimeDayOfWeek(Time[0])<5)))
           {
            res=OrderSend(Symbol(),OP_SELL,1,Bid,3,Chandelier_Dn+Point+Point*4,Ask-(30*Point),"SimbaSystemM1",MAGICSS,0,Red);
            ShortTrades++;
            LastSellPrice=Bid;
           }
        }

      LastMinute=Time[0];
     }

//----
   return(0);
  }
//+------------------------------------------------------------------+